﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

public partial class AdminMembers : System.Web.UI.Page
{
    dbclass obj = new dbclass();
    DataSet ds = new DataSet();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Convert.ToString(Session["aid"]) + "" != "")
        {
            if (!IsPostBack)
            {
                string TempValue = obj.BindPageAuthentication(Convert.ToInt32(Session["aid"]), Convert.ToString("AdminMembers.aspx"));
                if (TempValue != "")
                {
                    string[] ParamTempValue = TempValue.Split('#');
                    ViewState["Page_View"] = ParamTempValue[0].ToString();
                    ViewState["Page_Add"] = ParamTempValue[1].ToString();
                    ViewState["Page_Edit"] = ParamTempValue[2].ToString();
                    ViewState["Page_Delete"] = ParamTempValue[3].ToString();

                    ViewState["sortOrder"] = "";
                    bindgrid("", "");

                    if (ViewState["Page_Add"].ToString() == "True")
                    {
                        btnAdd.Visible = true;
                    }
                    else
                    {
                        btnAdd.Visible = false;
                    }
                }
                else
                {
                    Response.Redirect("Welcome.aspx?Return=Y");
                }
            }
        }
        else
        {
            //Response.Redirect("Index.aspx");
            Session["aid"] = "1";
            Response.Redirect("Welcome.aspx", false);
        }
    }

    public void bindgrid(string colname, string ord)
    {
        SqlParameter[] ParamList1 = new SqlParameter[3];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = 0;

        if (colname != "")
        {
            ParamList1[1] = new SqlParameter("@colname", colname);
        }
        else
        {
            ParamList1[1] = new SqlParameter("@colname", null);
        }
        if (ord != "")
        {
            ParamList1[2] = new SqlParameter("@ord", ord);
        }
        else
        {
            ParamList1[2] = new SqlParameter("@ord", null);
        }

        ds = obj.ddlDataProc("sp_tbl_Admin", ParamList1);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblmsg.Visible = false;
            tr_Form.Visible = false;
            tr_Grid.Visible = true;
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "There is no member details to display";
        }
        gv_AdminMembers.DataSource = ds;
        gv_AdminMembers.DataBind();

        ds.Clear();
        ParamList1 = null;
    }

    protected void gv_AdminMembers_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (ViewState["Page_Edit"].ToString() == "True")
        {
            e.Row.Cells[1].Visible = true;
        }
        else
        {
            e.Row.Cells[1].Visible = false;
        }

        if (ViewState["Page_Delete"].ToString() == "True")
        {
            e.Row.Cells[6].Visible = true;
        }
        else
        {
            e.Row.Cells[6].Visible = false;
        }

        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "S")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "Super Admin";
            }
            else if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "A")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "Admin";
            }
            else if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "O")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "Operator";
            }
        }
    }

    public void ClearFields()
    {
        txtName.Text = "";
        txtPassword.Text = "";
        rblType.ClearSelection();
        rblType.Items[0].Selected = true;
    }

    protected void btnAdd_Click(object sender, EventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = true;
        btnUpdate.Visible = false;
        lblmsg.Visible = false;
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[4];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "4";

        ParamList1[1] = new SqlParameter("@A_Username", SqlDbType.VarChar);
        ParamList1[1].Value = Convert.ToString(txtName.Text);

        ParamList1[2] = new SqlParameter("@A_Password", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtPassword.Text);

        ParamList1[3] = new SqlParameter("@A_Type", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(rblType.SelectedValue);

        if (obj.dmlDataProc("sp_tbl_Admin", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data inserted succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void btnBack_Click(object sender, EventArgs e)
    {
        ClearFields();
        gv_AdminMembers.EditIndex = -1;
        bindgrid("", "");
    }

    protected void gv_AdminMembers_RowEditing(object sender, GridViewEditEventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = false;
        btnUpdate.Visible = true;
        lblmsg.Visible = false;

        SqlParameter[] ParamList = new SqlParameter[2];

        ParamList[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList[0].Value = 7;

        ParamList[1] = new SqlParameter("@A_Id", SqlDbType.Int);
        ParamList[1].Value = gv_AdminMembers.DataKeys[e.NewEditIndex].Value;

        ViewState["gridid"] = gv_AdminMembers.DataKeys[e.NewEditIndex].Value;

        ds = obj.ddlDataProc("sp_tbl_Admin", ParamList);

        if (ds.Tables[0].Rows.Count > 0)
        {
            txtName.Text = ds.Tables[0].Rows[0]["A_Username"].ToString();
            txtPassword.Text = ds.Tables[0].Rows[0]["A_Password"].ToString();
            rblType.SelectedValue = ds.Tables[0].Rows[0]["A_Type"].ToString();
        }
        ds.Clear();
        ParamList = null;
    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[5];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "5";

        ParamList1[1] = new SqlParameter("@A_Username", SqlDbType.VarChar);
        ParamList1[1].Value = Convert.ToString(txtName.Text);

        ParamList1[2] = new SqlParameter("@A_Password", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtPassword.Text);

        ParamList1[3] = new SqlParameter("@A_Type", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(rblType.SelectedValue);

        ParamList1[4] = new SqlParameter("@A_Id", SqlDbType.Int);
        ParamList1[4].Value = Convert.ToInt32(ViewState["gridid"]);

        if (obj.dmlDataProc("sp_tbl_Admin", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data updated succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void gv_AdminMembers_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[2];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "6";

        ParamList1[1] = new SqlParameter("@A_Id", SqlDbType.Int);
        ParamList1[1].Value = gv_AdminMembers.DataKeys[e.RowIndex].Value;

        bool bldelart;
        bldelart = obj.dmlDataProc("sp_tbl_Admin", ParamList1);

        bindgrid("", "");
        if (bldelart == true)
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Record Deleted Successfully";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Records not Deleted sucessfully";
        }
        ParamList1 = null;
    }

    protected void btnBackToWelcome_Click(object sender, EventArgs e)
    {
        Response.Redirect("Welcome.aspx");
    }

    protected void gv_AdminMembers_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "View")
        {
            Response.Redirect("AdminPageAuthentication.aspx?Id=" + e.CommandArgument + "");
        }
    }
}