﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

public partial class ClientDetail : System.Web.UI.Page
{
    dbclass obj = new dbclass();
    DataSet ds = new DataSet();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Convert.ToString(Session["aid"]) + "" != "")
        {
            if (!IsPostBack)
            {
                string TempValue = obj.BindPageAuthentication(Convert.ToInt32(Session["aid"]), Convert.ToString("ClientDetail.aspx"));
                if (TempValue != "")
                {
                    string[] ParamTempValue = TempValue.Split('#');
                    ViewState["Page_View"] = ParamTempValue[0].ToString();
                    ViewState["Page_Add"] = ParamTempValue[1].ToString();
                    ViewState["Page_Edit"] = ParamTempValue[2].ToString();
                    ViewState["Page_Delete"] = ParamTempValue[3].ToString();

                    ViewState["sortOrder"] = "";
                    bindgrid("", "");

                    if (ViewState["Page_Add"].ToString() == "True")
                    {
                        btnAdd.Visible = true;
                    }
                    else
                    {
                        btnAdd.Visible = false;
                    }
                }
                else
                {
                    Response.Redirect("Welcome.aspx?Return=Y");
                }                          
            }
        }
        else
        {
            //Response.Redirect("Index.aspx");
            Session["aid"] = "1";
            Response.Redirect("Welcome.aspx", false);
        }        
    }    

    public void bindgrid(string colname, string ord)
    {
        SqlParameter[] ParamList1 = new SqlParameter[3];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = 0;

        if (colname != "")
        {
            ParamList1[1] = new SqlParameter("@colname", colname);
        }
        else
        {
            ParamList1[1] = new SqlParameter("@colname", null);
        }
        if (ord != "")
        {
            ParamList1[2] = new SqlParameter("@ord", ord);
        }
        else
        {
            ParamList1[2] = new SqlParameter("@ord", null);
        }

        ds = obj.ddlDataProc("sp_tbl_Company", ParamList1);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblmsg.Visible = false;
            tr_Form.Visible = false;
            tr_Grid.Visible = true;
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "There is no client details to display";
        }
        gv_Company.DataSource = ds;
        gv_Company.DataBind();

        ds.Clear();
        ParamList1 = null;
    }

    protected void gv_Company_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (ViewState["Page_Edit"].ToString() == "True")
        {
            e.Row.Cells[1].Visible = true;
        }
        else
        {
            e.Row.Cells[1].Visible = false;
        }

        if (ViewState["Page_Delete"].ToString() == "True")
        {
            e.Row.Cells[6].Visible = true;
        }
        else
        {
            e.Row.Cells[6].Visible = false;
        }

        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "True")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "Yes";
            }
            else if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "False")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "No";
            }
        }
    }

    public void ClearFields()
    {
        ddlClientType.ClearSelection();
        lblClientTypeDetail.Visible = false;
        txtTypeDetail.Visible = false;
        txtTypeDetail.Text = "";
        txtCompanyName.Text = "";
        txtCompanyAdd.Text = "";
        ddlState.ClearSelection();
        txtCountry.Text = "United Arab Emirates";
        txtPhone.Text = "";
        txtMobile.Text = "";
        txtFax.Text = "";
        txtEmailId.Text = "";
        txtWebsite.Text = "";
        rblPaymentMethod.ClearSelection();
        rblPaymentMethod.Items[0].Selected = true;
        rblDisplay.ClearSelection();
        rblDisplay.Items[0].Selected = true;
        txtEnteredBy.Text = "";
    }

    public void BindState()
    {
        DataSet dsTemp = new DataSet();

        string str = "Select * from tbl_State Where State_Active = 1";
        dsTemp = obj.GetData(str);

        if (dsTemp.Tables[0].Rows.Count > 0)
        {
            ddlState.DataSource = dsTemp;
            ddlState.DataValueField = dsTemp.Tables[0].Columns["State_Name"].ToString();
            ddlState.DataTextField = dsTemp.Tables[0].Columns["State_Name"].ToString();
            ddlState.DataBind();

            ddlState.Items.Insert(0, "Select");
        }
        dsTemp.Clear();
    }

    public void BindClientType()
    {
        DataSet dsTemp = new DataSet();

        //string str = "Select * from tbl_RequisitionType Where Type_Active = 1 And Type_Name <> 'Registered Client'";
        string str = "Select * from tbl_RequisitionType Where Type_Active = 1";
        dsTemp = obj.GetData(str);

        if (dsTemp.Tables[0].Rows.Count > 0)
        {
            ddlClientType.DataSource = dsTemp;
            ddlClientType.DataValueField = dsTemp.Tables[0].Columns["Type_Name"].ToString();
            ddlClientType.DataTextField = dsTemp.Tables[0].Columns["Type_Name"].ToString();
            ddlClientType.DataBind();

            ddlClientType.Items.Insert(0, "Select");
        }
        dsTemp.Clear();
    }

    protected void btnAdd_Click(object sender, EventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = true;
        btnUpdate.Visible = false;
        lblmsg.Visible = false;
        BindState();
        BindClientType();
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[15];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "1";

        ParamList1[1] = new SqlParameter("@Company_Type", SqlDbType.VarChar);
        ParamList1[1].Value = Convert.ToString(ddlClientType.SelectedValue);

        ParamList1[2] = new SqlParameter("@Company_Type_Detail", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtTypeDetail.Text);

        ParamList1[3] = new SqlParameter("@Company_Name", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(txtCompanyName.Text);

        ParamList1[4] = new SqlParameter("@Company_Address", SqlDbType.VarChar);
        ParamList1[4].Value = Convert.ToString(txtCompanyAdd.Text);

        ParamList1[5] = new SqlParameter("@Company_State", SqlDbType.VarChar);
        ParamList1[5].Value = Convert.ToString(ddlState.SelectedValue);

        ParamList1[6] = new SqlParameter("@Company_Country", SqlDbType.VarChar);
        ParamList1[6].Value = Convert.ToString(txtCountry.Text);

        ParamList1[7] = new SqlParameter("@Company_Contact_Phone", SqlDbType.VarChar);
        ParamList1[7].Value = Convert.ToString(txtPhone.Text);

        ParamList1[8] = new SqlParameter("@Company_Contact_Mobile", SqlDbType.VarChar);
        ParamList1[8].Value = Convert.ToString(txtMobile.Text);

        ParamList1[9] = new SqlParameter("@Company_Fax", SqlDbType.VarChar);
        ParamList1[9].Value = Convert.ToString(txtFax.Text);

        ParamList1[10] = new SqlParameter("@Company_EmailId", SqlDbType.VarChar);
        ParamList1[10].Value = Convert.ToString(txtEmailId.Text);

        ParamList1[11] = new SqlParameter("@Company_Website", SqlDbType.VarChar);
        ParamList1[11].Value = Convert.ToString(txtWebsite.Text);

        ParamList1[12] = new SqlParameter("@Company_Payment_Method", SqlDbType.VarChar);
        ParamList1[12].Value = Convert.ToString(rblPaymentMethod.SelectedValue);

        ParamList1[13] = new SqlParameter("@Company_Active", SqlDbType.Bit);
        ParamList1[13].Value = Convert.ToBoolean(rblDisplay.SelectedValue);

        ParamList1[14] = new SqlParameter("@Details_Entered_By", SqlDbType.VarChar);
        ParamList1[14].Value = Convert.ToString(txtEnteredBy.Text);

        if (obj.dmlDataProc("sp_tbl_Company", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data inserted succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void btnBack_Click(object sender, EventArgs e)
    {
        ClearFields();
        gv_Company.EditIndex = -1;
        bindgrid("", "");
    }

    protected void gv_Company_RowEditing(object sender, GridViewEditEventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = false;
        btnUpdate.Visible = true;
        lblmsg.Visible = false;
        SqlParameter[] ParamList = new SqlParameter[2];

        ParamList[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList[0].Value = 4;

        ParamList[1] = new SqlParameter("@Company_Id", SqlDbType.Int);
        ParamList[1].Value = gv_Company.DataKeys[e.NewEditIndex].Value;

        ViewState["gridid"] = gv_Company.DataKeys[e.NewEditIndex].Value;

        ds = obj.ddlDataProc("sp_tbl_Company", ParamList);

        if (ds.Tables[0].Rows.Count > 0)
        {
            BindClientType();
            ddlClientType.SelectedValue = ds.Tables[0].Rows[0]["Company_Type"].ToString();
            BindClientTypeSelection();
            txtTypeDetail.Text = ds.Tables[0].Rows[0]["Company_Type_Detail"].ToString();
            txtCompanyName.Text = ds.Tables[0].Rows[0]["Company_Name"].ToString();
            txtCompanyAdd.Text = ds.Tables[0].Rows[0]["Company_Address"].ToString();
            BindState();
            ddlState.SelectedValue = ds.Tables[0].Rows[0]["Company_State"].ToString();
            txtCountry.Text = ds.Tables[0].Rows[0]["Company_Country"].ToString();
            txtPhone.Text = ds.Tables[0].Rows[0]["Company_Contact_Phone"].ToString();
            txtMobile.Text = ds.Tables[0].Rows[0]["Company_Contact_Mobile"].ToString();
            txtFax.Text = ds.Tables[0].Rows[0]["Company_Fax"].ToString();
            txtEmailId.Text = ds.Tables[0].Rows[0]["Company_EmailId"].ToString();
            txtWebsite.Text = ds.Tables[0].Rows[0]["Company_Website"].ToString();
            rblPaymentMethod.SelectedValue = ds.Tables[0].Rows[0]["Company_Payment_Method"].ToString();
            rblDisplay.SelectedValue = ds.Tables[0].Rows[0]["Company_Active"].ToString();
            txtEnteredBy.Text = ds.Tables[0].Rows[0]["Details_Entered_By"].ToString();
        }
        ds.Clear();
        ParamList = null;
    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[16];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "2";

        ParamList1[1] = new SqlParameter("@Company_Type", SqlDbType.VarChar);
        ParamList1[1].Value = Convert.ToString(ddlClientType.SelectedValue);

        ParamList1[2] = new SqlParameter("@Company_Type_Detail", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtTypeDetail.Text);

        ParamList1[3] = new SqlParameter("@Company_Name", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(txtCompanyName.Text);

        ParamList1[4] = new SqlParameter("@Company_Address", SqlDbType.VarChar);
        ParamList1[4].Value = Convert.ToString(txtCompanyAdd.Text);

        ParamList1[5] = new SqlParameter("@Company_State", SqlDbType.VarChar);
        ParamList1[5].Value = Convert.ToString(ddlState.SelectedValue);

        ParamList1[6] = new SqlParameter("@Company_Country", SqlDbType.VarChar);
        ParamList1[6].Value = Convert.ToString(txtCountry.Text);

        ParamList1[7] = new SqlParameter("@Company_Contact_Phone", SqlDbType.VarChar);
        ParamList1[7].Value = Convert.ToString(txtPhone.Text);

        ParamList1[8] = new SqlParameter("@Company_Contact_Mobile", SqlDbType.VarChar);
        ParamList1[8].Value = Convert.ToString(txtMobile.Text);

        ParamList1[9] = new SqlParameter("@Company_Fax", SqlDbType.VarChar);
        ParamList1[9].Value = Convert.ToString(txtFax.Text);

        ParamList1[10] = new SqlParameter("@Company_EmailId", SqlDbType.VarChar);
        ParamList1[10].Value = Convert.ToString(txtEmailId.Text);

        ParamList1[11] = new SqlParameter("@Company_Website", SqlDbType.VarChar);
        ParamList1[11].Value = Convert.ToString(txtWebsite.Text);

        ParamList1[12] = new SqlParameter("@Company_Payment_Method", SqlDbType.VarChar);
        ParamList1[12].Value = Convert.ToString(rblPaymentMethod.SelectedValue);

        ParamList1[13] = new SqlParameter("@Company_Active", SqlDbType.Bit);
        ParamList1[13].Value = Convert.ToBoolean(rblDisplay.SelectedValue);

        ParamList1[14] = new SqlParameter("@Details_Entered_By", SqlDbType.VarChar);
        ParamList1[14].Value = Convert.ToString(txtEnteredBy.Text);

        ParamList1[15] = new SqlParameter("@Company_Id", SqlDbType.Int);
        ParamList1[15].Value = Convert.ToInt32(ViewState["gridid"]);

        if (obj.dmlDataProc("sp_tbl_Company", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data updated succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void gv_Company_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[2];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "3";

        ParamList1[1] = new SqlParameter("@Company_Id", SqlDbType.Int);
        ParamList1[1].Value = gv_Company.DataKeys[e.RowIndex].Value;

        bool bldelart;
        bldelart = obj.dmlDataProc("sp_tbl_Company", ParamList1);

        bindgrid("", "");
        if (bldelart == true)
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Record Deleted Successfully";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Records not Deleted sucessfully";
        }
        ParamList1 = null;
    }

    protected void gv_Company_RowCommand(object sender, GridViewCommandEventArgs e)
    {
        if (e.CommandName == "Person")
        {
            Response.Redirect("ClientDetail_PersonList.aspx?Id=" + e.CommandArgument + "");
        }
    }

    protected void ddlClientType_SelectedIndexChanged(object sender, EventArgs e)
    {
        BindClientTypeSelection();   
    }

    public void BindClientTypeSelection()
    {
        if (ddlClientType.SelectedValue.ToString() == "Walk-In" || ddlClientType.SelectedValue.ToString() == "Registered Client" || ddlClientType.SelectedValue.ToString() == "Select")
        {
            lblClientTypeDetail.Visible = false;
            txtTypeDetail.Visible = false;
        }
        else
        {
            lblClientTypeDetail.Visible = true;
            txtTypeDetail.Visible = true;
        }
    }
}