﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;
using Num2Wrd;

public partial class Quotation_Print : System.Web.UI.Page
{
    dbclass obj = new dbclass();
    DataSet ds = new DataSet();
    NumberToEnglish numToeng = new NumberToEnglish();
    double amount = 0;
    double subtotal = 0;

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (Request.QueryString["Id"] + "" != "")
            {                
                bindgrid("", "");
                BindDetail();
            }
        }
    }

    public void BindDetail()
    {
        string str = "SELECT tbl_QuotationMaster.*, tbl_QuotationDetail.* FROM tbl_QuotationMaster INNER JOIN tbl_QuotationDetail ON tbl_QuotationMaster.Quo_Id = tbl_QuotationDetail.Quo_Id WHERE tbl_QuotationMaster.Quo_Id = " + Convert.ToInt32(Request.QueryString["Id"]) + "";
        ds = obj.GetData(str);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblQuotationCode.Text = ds.Tables[0].Rows[0]["Quo_Serial_No"].ToString();
            lblDate.Text = Convert.ToDateTime(ds.Tables[0].Rows[0]["Quo_Reg_Date"]).ToString("dd/MM/yyyy");
            if (ds.Tables[0].Rows.Count == 1)
            {
                if (ds.Tables[0].Rows[0]["ReqM_Serial_No"].ToString() != "0" && ds.Tables[0].Rows[0]["ReqM_Serial_No"].ToString() != "")
                {
                    lblSubject.Text = ds.Tables[0].Rows[0]["QuoDet_Product_Name"].ToString() + " - " + ds.Tables[0].Rows[0]["ReqM_Serial_No"].ToString();
                }
                else
                {
                    lblSubject.Text = ds.Tables[0].Rows[0]["QuoDet_Product_Name"].ToString();
                }
            }
            else
            {
                lblSubject.Text = "Quotation";
            }
            if (ds.Tables[0].Rows[0]["Company_Id"].ToString() == "0" && ds.Tables[0].Rows[0]["CompClient_Id"].ToString() == "0")
            {
                lblCompName.Text = ds.Tables[0].Rows[0]["Quo_Company_Name"].ToString();
                lblCompState.Text = ds.Tables[0].Rows[0]["Quo_Company_State"].ToString();
                lblCompCountry.Text = ds.Tables[0].Rows[0]["Quo_Company_Country"].ToString();
                lblCompClient.Text = ds.Tables[0].Rows[0]["Quo_CompClient_Name"].ToString();
                lblCompFax.Text = ds.Tables[0].Rows[0]["Quo_Company_Fax"].ToString();
                lblCompTelphone.Text = ds.Tables[0].Rows[0]["Quo_Company_Contact_Phone"].ToString();
            }
            else
            {
                BindViewOfCompany(Convert.ToInt32(ds.Tables[0].Rows[0]["Company_Id"]), Convert.ToInt32(ds.Tables[0].Rows[0]["CompClient_Id"]));
            }
        }
        ds.Clear();
    }

    public void bindgrid(string colname, string ord)
    {
        SqlParameter[] ParamList1 = new SqlParameter[4];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = 0;

        if (colname != "")
        {
            ParamList1[1] = new SqlParameter("@colname", colname);
        }
        else
        {
            ParamList1[1] = new SqlParameter("@colname", null);
        }
        if (ord != "")
        {
            ParamList1[2] = new SqlParameter("@ord", ord);
        }
        else
        {
            ParamList1[2] = new SqlParameter("@ord", null);
        }

        ParamList1[3] = new SqlParameter("@Quo_Id", SqlDbType.Int);
        ParamList1[3].Value = Convert.ToInt32(Request.QueryString["Id"]);

        ds = obj.ddlDataProc("sp_tbl_QuotationDetail", ParamList1);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblmsg.Visible = false;
            tblSubTotal.Visible = true;
        }
        else
        {
            tblSubTotal.Visible = false;
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "There is no quotation details to display";
        }

        gv_QuotationDetail.DataSource = ds;
        gv_QuotationDetail.DataBind();

        ds.Clear();
        ParamList1 = null;
    }

    public void BindViewOfCompany(int TempCompany, int TempClient)
    {
        DataSet dsView = new DataSet();

        string str = "SELECT tbl_Company.*, tbl_CompanyClient.* FROM tbl_Company INNER JOIN tbl_CompanyClient ON tbl_Company.Company_Id = tbl_CompanyClient.Company_Id WHERE tbl_Company.Company_Id = " + TempCompany + " AND tbl_CompanyClient.CompClient_Id = " + TempClient + "";
        dsView = obj.GetData(str);

        if (dsView.Tables[0].Rows.Count > 0)
        {
            lblCompName.Text = dsView.Tables[0].Rows[0]["Company_Name"].ToString();
            lblCompState.Text = dsView.Tables[0].Rows[0]["Company_State"].ToString();
            lblCompCountry.Text = dsView.Tables[0].Rows[0]["Company_Country"].ToString();
            lblCompClient.Text = dsView.Tables[0].Rows[0]["CompClient_Name"].ToString();
            lblCompFax.Text = dsView.Tables[0].Rows[0]["Company_Fax"].ToString();
            lblCompTelphone.Text = dsView.Tables[0].Rows[0]["Company_Contact_Phone"].ToString();
        }
        dsView.Clear();
    }
    
    protected void gv_QuotationDetail_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType != DataControlRowType.Header && e.Row.RowType != DataControlRowType.Footer)
        {
            Label lblAmt = ((Label)e.Row.FindControl("lblAmt"));
            Label pPrice = ((Label)e.Row.FindControl("lblPrice"));
            Label lblQty = ((Label)e.Row.FindControl("lblQty"));

            amount = Convert.ToDouble(pPrice.Text) * Convert.ToDouble(lblQty.Text);
            lblAmt.Text = string.Format("{0:0.00}", amount);
            subtotal = subtotal + amount;
        }

        lblSubTotal.Text = string.Format("{0:0.00}", subtotal);

        lblAmountInWords.Text = numToeng.changeCurrencyToWords(subtotal);
    }
}